/*
DB֘AANZX@\
create: 2000/11/08 14:20 by Tsukasa Jitoh
update:
*/

// logging file name
var sDbAccessLogFileName = null;
var iDbAccessiDmlFilter = 0;

//D.B. Open
function conOpenDB(sDsn, iAdoCommandTimeout, sLogFile, iDmlFilter, sP1, sP2)
{
	sDbAccessLogFileName = sLogFile;
	if(!iAdoCommandTimeout)
		iAdoCommandTimeout = 3000;
	if(!iDmlFilter)
		iDbAccessiDmlFilter = iDmlFilter;

	// Create ADO Connection Component to connect with database
	var oConn = new ActiveXObject("ADODB.Connection");
	oConn.CommandTimeout = iAdoCommandTimeout;
/*	var sFileDsn = sNZ(sDsn);
	if(sFileDsn.substr(0, 1) == "." && typeof(Server) != "undefined")
		sFileDsn = Server.MapPath(sFileDsn);
	oConn.Open("FILEDSN=" + sFileDsn, (sP1? sP1: ""), (sP2? sP2: ""));
*/
	oConn.Open(sDsn, (sP1? sP1: ""), (sP2? sP2: ""));
	vLogFile("Connection Open!", sDbAccessLogFileName);
	return oConn;
}
//make rs
function rsCreateRs()
{
	var oRs = new ActiveXObject("ADODB.Recordset");
	return oRs;
}
//request
function vOpenRs(oConn, oRs, sSql, iPara3, iPara4)
{
	sSql = sDmlFilter(sSql);
/*
  const data for '.Open' 3rd param
	adOpenUnspecified = 0xffffffff,
	adOpenForwardOnly = 0,
	adOpenKeyset = 1,
	adOpenDynamic = 2,
	adOpenStatic = 3,
  const data for '.Open' 4th param
	adLockUnspecified = 0xffffffff,
	adLockReadOnly = 1,
	adLockPessimistic = 2,
	adLockOptimistic = 3,
	adLockBatchOptimistic = 4
*/
//	var i3 = (iPara3)? iPara3: 2;
//	var i4 = (iPara4)? iPara4: 2;
//ANZXɃG[ɂȂP[XׁArÂ
	var i3 = (iPara3)? iPara3: 3;
	var i4 = (iPara4)? iPara4: 3;
	var oNow = new Date();
	try {
		vLogFile(sSql, sDbAccessLogFileName);
		oRs.Open(sSql, oConn, i3, i4);
	} catch(e) {
//	vW(sSql);
		vLogEvent(null, 1, e.description + "\r\n" + sSql, oNow);
		throw e;
	} finally {
		vLogFile(sSql, sDbAccessLogFileName, oNow);
	}
}
//execute SQL(for use recordset)
function rsExecuteSql(oConn, sSql)
{
	sSql = sDmlFilter(sSql);
	var oRc = null;
	var oNow = new Date();
	try {
		vLogFile(sSql, sDbAccessLogFileName);
		oRc = oConn.Execute(sSql);
	} catch(e) {
		vLogEvent(null, 1, e.description + "\r\n" + sSql, oNow);
		throw e;
	} finally {
		vLogFile(sSql, sDbAccessLogFileName, oNow);
	}
	return oRc;
}
//execute SQL(for none use recordset)
function bExecuteSql(oConn, sSql)
{
	sSql = sDmlFilter(sSql);
	var bRc = false;
	var oNow = new Date();
	try {
		vLogFile(sSql, sDbAccessLogFileName);
		bRc = bExecuteSqlVbs(oConn, sSql);
	} catch(e) {
		vLogEvent(null, 1, e.description + "\r\n" + sSql, oNow);
		throw e;
	} finally {
		vLogFile(sSql, sDbAccessLogFileName, oNow);
	}
	return bRc;
}
//f[^ݒ
// f[^tB[hTCYɐ؂l߂Đݒ
function vSetRs(rs, sFld, oData)
{
	if(rs.Fields(sFld).type == 129			//char
		|| rs.Fields(sFld).type == 200		//VARCHAR2(Oracle)
		|| rs.Fields(sFld).type == 202		//varchar(MS)
	)
		rs.Fields(sFld) =
			sStrBSubstr(sZN(oData), 0, rs.Fields(sFld).Definedsize);
	else
		rs.Fields(sFld) = oData;
}
//close recodeset
function vCloseRs(oRs)
{
	oRs.Close();
	vLogFile("Rec Close!", sDbAccessLogFileName);
}
//free recodeset
function vFreeRs(oRs)
{
	if(oRs != null)
		delete oRs;
	oRs = null;
}
//close D.B.
function vCloseDB(oConn)
{
	if(oConn != null)
	{
		oConn.Close();
		delete oConn;
	}
	oConn = null;
	vLogFile("Connection Close!", sDbAccessLogFileName);
}
//start transaction set
function oTransaction(oConn, fnBody, oParam, fnErr, fnFin)
{
	var oRc = null;
	oConn.BeginTrans();
	try {
		oRc = fnBody(oConn, oParam);
		oConn.CommitTrans();
	} catch(e) {
		oConn.RollbackTrans();
		if(fnErr)
			fnErr(oConn, oParam, e);
		var s = oTransaction.caller;
		if(s)
		{
			s = s.toString();
			s = s.substring(9, s.search("\r"));
		}
		s = "[@\=oTransaction:" +
			"e=" + s + ":Err=" + e.description + "]";
		Response.AppendToLog(s);
	} finally {
		if(fnFin)
			fnFin(oConn, oParam);
	}
	return oRc;
}
//LookuptB[hl擾
function sLuDB(oConn, sMatch, sName, sKey, sValue)
{
	var rs = rsCreateRs();
	var sSql = "SELECT " + sValue + " FROM " + sName +
		" WHERE " + sKey + " = " + sMatch;
	vOpenRs(oConn, rs, sDmlFilter(sSql));
	var sRc = "";
	if(!rs.EOF)
	{
		sRc = sNZ(rs(0).value);
	}
	vCloseRs(rs);
	vFreeRs(rs);
	return sRc;
}
//DML tB^
function sDmlFilter(sDml)
{
	var s = sDml;
	if(iDbAccessiDmlFilter == 1)			//jet...܂
	{
		//a = b(+) -> a = b...Ƃ肠ʂ
		s = s.replace(/\(\+\)/g, "");
		//a || b -> a & b
		s = s.replace(/\s+\|\|\s+/g, " & ");
	}
	else if(iDbAccessiDmlFilter == 2)	//SQL Server(MSDE)
	{
		//a = b(+) -> a *= b
		s = s.replace(/(\w*\.*\w+)\s+=\s+(\w*\.*\w+)\(\+\)/g,"$1 *= $2");
		s = s.replace(/(\w*\.*\w+)\(\+\)\s+=\s+(\w*\.*\w+)/g,"$1 =* $2");
		//a || b -> isnull(a,'') + isnull(b,'')
		s = s.replace(/(\w*\.*\w+)\s+\|\|\s+/g,"[isnull]($1,'') + ");
		s = s.replace(/\,''\)\s+\+\s+(\w*\.*\w+)/g,
			",'') + isnull($1,'')");
		s = s.replace(/\[isnull\]\(/g,"isnull(");
		s = s.replace(/\s+\|\|\s+/g," + ");
		//nvl -> isnull
		s = s.replace(/\s+nvl\(/ig," isnull(");
	}
	return s;
}

